﻿using DotNetCore.CAP;
using Hotline.Share.Dtos.Order;
using MediatR;
using Microsoft.AspNetCore.Mvc;
using Sharing.Application;
using Sharing.Notifications;
using Sharing.Orders;
using Sharing.WebCore;
using System.Threading;

namespace Sharing.Api.Controllers
{
    public class HotlineMessageReceiveController : Controller
    {
        private readonly IDataOrderRepository _dataOrderRepository;
        private readonly IMediator _mediator;
        private readonly ILogger<HotlineMsgReceiver> _logger;

        public HotlineMessageReceiveController(
            IDataOrderRepository dataOrderRepository,
            IMediator mediator,
            ILogger<HotlineMsgReceiver> logger)
        {
            _dataOrderRepository = dataOrderRepository;
            _mediator = mediator;
            _logger = logger;
        }

        [NonAction]
        [CapSubscribe(Hotline.Share.Mq.EventNames.HotlineOrderCreated)]
        public async Task ReceiveOrderCreated(OrderDto dto)
        {
            //todo receive mq msg, write into db, publish inprocess msg
            _logger.LogInformation("rec order");
           // await _dataOrderRepository.AddAsync(new DataOrder(), HttpContext.RequestAborted);

          //  await _mediator.Publish(new OrderCreatedNotification(new DataOrder()), HttpContext.RequestAborted);
            _logger.LogInformation("publish order success!");
        }
    }
}
