﻿using MapsterMapper;
using Microsoft.AspNetCore.Mvc;
using Sharing.Province.Dtos.XieTong;
using Sharing.Province.XieTong;
using Sharing.WebCore;

namespace Sharing.Province.Controllers
{
    /// <summary>
    /// 
    /// </summary>
    public class ReceiveController : BaseController
    {
        private readonly IMapper _mapper;
        private readonly IReceiveCaseInfoRepository _receiveCaseInfoRepository;

        /// <summary>
        /// 
        /// </summary>
        /// <param name="mapper"></param>
        /// <param name="receiveCaseInfoRepository"></param>
        public ReceiveController(IMapper mapper, IReceiveCaseInfoRepository receiveCaseInfoRepository)
        {
            _mapper = mapper;
            _receiveCaseInfoRepository = receiveCaseInfoRepository;
        }

        /// <summary>
        /// 服务工单交办接口
        /// </summary>
        /// <param name="receiveCaseInfo"></param>
        /// <returns></returns>
        [HttpPost("receive_case_info")]
        public async Task<string> ReceiveCaseInfo([FromBody] ReceiveCaseInfoRequest receiveCaseInfo)
        {
            //验证接收的数据是否正确
            string strResult = receiveCaseInfo.paras.Validate();
            if (false == string.IsNullOrEmpty(strResult))
                return strResult;

            //转换数据
            var dto = _mapper.Map<ReceiveCaseInfo>(receiveCaseInfo.paras);
            dto.SyncState = "0";
            //添加数据
            var id = await _receiveCaseInfoRepository.AddAsync(dto, HttpContext.RequestAborted);

            //处理组装数据，推送数据
            
            return id;
        }
    }
}
