﻿using Sharing.Province.Dtos;
using Sharing.Province.Dtos.HuiJu;
using XF.Domain.Dependency;

namespace Sharing.Province;

/// <summary>
/// 默认策略（保持原数据策略）
/// </summary>
public class DefaultPusher : IProvincePusher
{
    private readonly HuiJuClient _huiJuClient;
    private readonly XieTongClient _xieTongClient;

    public DefaultPusher(HuiJuClient huiJuClient, XieTongClient xieTongClient)
    {
        _huiJuClient = huiJuClient;
        _xieTongClient = xieTongClient;
    }

    public async Task PushOrderCreatedAsync(SubmitCaseInfoRequest request, CancellationToken cancellationToken)
    {
        var response = await _huiJuClient.RequestAsync<SubmitCaseInfoRequest, ProvinceResponse>(request, cancellationToken);
    }
}